open Graph


type 'a network = {
  graph: 'a graph;
  origin: id;
  destination: id;
}

type flow = {
  current: int;
  capacity: int;
}

type path = (id * id) list

(* // TODO REMOVE AFTER TESTS *)
val initialize_graph: int graph -> flow graph

val apply_path: flow graph -> path -> int -> flow graph

val build_res_graph: flow graph -> int graph

val find_min: int graph -> path -> int

val find_path: int network -> path

(* KEEP THIS *)
val run_ff: int network -> flow network

val get_max_flow: flow network -> int